routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'SiteController@index')->name('inicio');
Route::get('/pg/{destaque}/{pagina}', 'SiteController@pagina')->name('pagina');
Route::get('/sobre', 'SiteController@sobre')->name('sobre');
Route::get('/profissionais-parceiros', 'SiteController@profissionaisParceiros')->name('profissionais-parceiros');
Route::get('/posts', 'SiteController@posts')->name('posts');
Route::get('/especialidades', 'SiteController@especialidades')->name('especialidades');
Route::get('/posts/{slug}', 'SiteController@postagem')->name('posts.postagem');
Route::get('/contato', 'SiteController@contato')->name('contato');
Route::post('/enviar-email', 'SiteController@enviarEmail')->name('enviar-email');

Route::get('erro', function(){
	return view('site/404');
})->name('erro');


Auth::routes();
Route::get('/home', 'HomeController@index')->name('home');

Auth::routes();
Route::resource('admin/posts', 'PostsController');

Auth::routes();
Route::get('/home', 'HomeController@index')->name('home');

Auth::routes();
Route::resource('admin/especialidades', 'EspecialidadesController');


Auth::routes();
Route::resource('admin/destaques', 'DestaquesController');

app/Post.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Str;
use Carbon\Carbon;

class Post extends Model
{

	protected $table    = 'posts';
	protected $fillable = [
		'capa',
		'data_hora',
		'titulo',
		'subtitulo',
		'texto',
		'slug',
		'visualizacoes'
	];

	public static function boot()
	{
		parent::boot();

		static::saving(function($model)
		{
        	//dd(Str::slug($model->titulo, '-'));
			$model->slug =  Str::slug($model->titulo, '-');;
			return true;
		});
	}


	public function getDataHoraAttribute($value)
	{
		if($value){
			$data = str_replace('/', '-', $value);
			return date('d/m/Y', strtotime($data));

		}
	}

	public function setDataHoraAttribute($value)
	{
		if($value){
			$data = str_replace('/', '-', $value);

			$this->attributes['data_hora'] =  date('Y-m-d', strtotime($data));
		}
	}

	public function getCreatedAtAttribute($value)
	{
		if($value){
			$data = str_replace('/', '-', $value);
			return date('d/m/Y H:i:s', strtotime($data));
		}
	} 

	public function getDataHoraExtensoAttribute()
	{
		setlocale(LC_ALL, 'pt_BR', 'pt_BR.iso-8859-1', 'pt_BR.utf-8', 'portuguese');
		
		
		return Carbon::parse(date('Y-m-d', strtotime($this->attributes['data_hora'])))->formatLocalized('%d de %B de %Y');
	}

	public function getImagemAttribute()
	{
		if($this->capa != null){
			return asset('imagem/thumbnail/'.$this->capa);
		}else{
			return asset('imagem/site/default-image.jpg');
		}
	}

	public function getParteDescricaoAttribute(){
		if($this->texto)
			
			return mb_substr(strip_tags(html_entity_decode($this->texto)), 0, 300, "utf-8" ) . ' ...';
		else
			return null;
	}	

	public function getParteDescricaoMaiorAttribute(){
		if($this->texto)
			return mb_substr(strip_tags(html_entity_decode($this->texto)), 0, 550, "utf-8" ) . ' ...';
		else
			return null;
	}

}

app/Http/Controllers/PostsController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Post;
use App\Http\Requests\PostsRequest;
use DB;
use Image;
use Storage;


class PostsController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    private $view = 'posts/';

    public function __construct()
    {
        $this->middleware('auth');
    }

    public function index()
    {
        $registros = Post::orderBy('id','desc')
        ->get();
        //dd($registros);

        return view($this->view.'index', compact('registros'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view($this->view.'criar_editar');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(PostsRequest $request)
    {
        //dd($request->all());
        try {
            DB::beginTransaction();

            if($request->hasFile('arquivo_principal')){
                $image = $request->file('arquivo_principal');
                $request['capa'] = time().'.'.$image->extension();

                if (!file_exists('imagem/thumbnail')) {
                    mkdir('imagem/thumbnail', 0777, true);
                }

                $destinationPath = public_path('imagem/thumbnail');

                $img = Image::make($request->imagebase64)->encode($image->getClientOriginalExtension());


                $img->save($destinationPath.'/'.$request['capa']);


                $destinationPath = public_path('/imagem');
                $image->move($destinationPath, $request['capa']);
            }


            Post::create($request->all());
        } catch (\Illuminate\Database\QueryException $e) {

            DB::rollBack();

            return redirect()->route('posts.index')->with('error','Não foi possível cadastrar!');
        }

        DB::commit();

        return redirect()->route('posts.index')->with('notice', 'Registro cadastrado!');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $registro = Post::find($id);
        
        return view($this->view.'criar_editar', compact('registro'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        try {
            $post =  Post::find($id);

            DB::beginTransaction();

            if($request->hasFile('arquivo_principal')){
                $image = $request->file('arquivo_principal');

                if($post->capa != null){
                    unlink("imagem/".$post->capa);
                    unlink("imagem/thumbnail/".$post->capa);
                }

                $request['capa'] = time().'.'.$image->extension();

                if (!file_exists('imagem/thumbnail')) {
                    mkdir('imagem/thumbnail', 0777, true);
                }

                $destinationPath = public_path('imagem/thumbnail');
                $img = Image::make($request->imagebase64)->encode($image->getClientOriginalExtension());


                $img->save($destinationPath.'/'.$request['capa']);

                $destinationPath = public_path('/imagem');
                $image->move($destinationPath, $request['capa']);
            }

            $post->update($request->all());
        } catch (\Illuminate\Database\QueryException $e) {

            DB::rollBack();

            return redirect()->route('posts.index')->with('error','Não foi possível alterar!');
        }

        DB::commit();

        return redirect()->route('posts.index')->with('notice', 'Registro alterado com sucesso!');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        try {
            DB::beginTransaction();

            $post =  Post::find($id);

            if($post->capa != null){
                unlink("imagem/".$post->capa);
                unlink("imagem/thumbnail/".$post->capa);
            }

            $post->delete();

        } catch (\Exception $e) {
            DB::rollBack();
            return back()->with('error','Não foi possível excluir!');
        }

        DB::commit();
        return redirect()->route('posts.index')->with('notice', 'Registro excluído com sucesso!');
    }
}

resources/views/posts/criar_editar.blade.php
@extends('layout.base')

@section('title', 'Posts')

@section('content_header')
    <h1>Posts</h1>
@stop

@section('breadcrumb')
    <li class="breadcrumb-item"><a href="{{ route('posts.index') }}">Posts</a></li>
    <li class="breadcrumb-item active"> {{ isset($registro) ? 'Editar' : 'Novo' }} </li>

@endsection

@section('acoes')
    <a href="{{ route('home') }}" class="btn btn-sm btn-default" data-toggle="tooltip" title="Voltar">
        <i class="fa fa-reply"></i> Voltar
    </a>
@endsection

@section('content')
@section('plugins.Summernote', true)
@section('plugins.Croppie', true)

<div class="row">
    <div class="col-md-12">
        {{-- @include('tema::mensagem') --}}
        <div class="card">
            <div class="card-body table-responsive">
                @if (isset($registro))
                    <form action="{{ route('posts.update', $registro->id) }}" method="post"
                        enctype="multipart/form-data">
                        <input type="hidden" name="_method" value="PUT">
                    @else
                        <form action="{{ route('posts.store') }}" method="post" enctype="multipart/form-data">

                @endif

                <input type="hidden" name="_token" value="{{ csrf_token() }}">

                <div class="row">
                    <div class="col-xs-12 col-md-12 mb-3">
                        <label>Título</label>
                        <input type="text" name="titulo"
                            class="form-control {{ $errors->has('titulo') ? 'is-invalid' : '' }}"
                            value="{{ old('titulo') ?? ($registro->titulo ?? null) }}" placeholder="Título" autofocus>
                        @if ($errors->has('titulo'))
                            <div class="invalid-feedback">
                                <strong>{{ $errors->first('titulo') }}</strong>
                            </div>
                        @endif
                    </div>
                    <div class="col-xs-12 col-md-9 mb-3">
                        <label>Subtítulo</label>
                        <input type="text" name="subtitulo"
                            class="form-control {{ $errors->has('subtitulo') ? 'is-invalid' : '' }}"
                            value="{{ old('subtitulo') ?? ($registro->subtitulo ?? null) }}" placeholder="Subtítulo">
                        @if ($errors->has('subtitulo'))
                            <div class="invalid-feedback">
                                <strong>{{ $errors->first('subtitulo') }}</strong>
                            </div>
                        @endif
                    </div>
                    <div class="col-xs-12 col-md-3">
                        <div class="form-group {{ $errors->has('data_hora') ? 'has-error' : null }}">
                            <label>Data do Post </label>

                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <span class="input-group-text"><i class="far fa-calendar-alt"></i></span>
                                </div>
                                <input name="data_hora" placeholder="00/00/0000" type="text"
                                    class="form-control {{ $errors->has('data_hora') ? 'is-invalid' : '' }} mask"
                                    data-inputmask-alias="datetime" data-inputmask-inputformat="dd/mm/yyyy" data-mask
                                    value="{{ old('data_hora') ?? ($registro->data_hora ?? null) }}">
                                @if ($errors->has('data_hora'))
                                    <div class="invalid-feedback">
                                        <strong>{{ $errors->first('data_hora') }}</strong>
                                    </div>
                                @endif
                            </div>
                        </div>
                    </div>
                    <div class="col-md-5 col-lg-5">
                        <div class="row">
                            <div class="img-content">
                                <div class="col-md-12">
                                    <label for="exampleInputFile">Imagem</label>
                                    (350 x 255)

                                    <div class="alert alert-info" id="aviso-remover" @if (!isset($registro) || (isset($registro) && $registro->capa == null)) style="display: none;" @endif>
                                        <i class="fa fa-info-circle"></i>
                                        <button type="button" class="close" data-dismiss="alert"
                                            aria-hidden="true">×</button>
                                        <small>
                                            Caso deseje escolher outra imagem clique no botão "Remover Imagem" e em
                                            seguida clique em "Selecionar Imagem".
                                        </small>
                                    </div>

                                    <div class="alert alert-info" id="aviso-mover" @if (isset($registro) && $registro->capa != null) style="display: none;" @endif>

                                        <i class="fa fa-info-circle"></i>
                                        <button type="button" class="close" data-dismiss="alert"
                                            aria-hidden="true">×</button>

                                        <small>
                                            Se desejar, clique e arraste a foto para cima ou para baixo para
                                            reposicioná-la
                                        </small>
                                    </div>


                                    <div class="img-foto-wrap">

                                        @if (isset($registro) && $registro->capa != null)
                                            <img class=" foto img-responsive"
                                                src="{{ $registro->getImagemAttribute() }}" alt="Imagem Principal">
                                        @endif
                                        <div id="img-foto"
                                            data-img-default-foto="{{ asset('imagem/site/default-image.jpg') }}"
                                            @if (isset($registro) && $registro->capa != null) style="display: none;" @endif></div>
                                        <input type="hidden" id="imagebase64" name="imagebase64" />

                                    </div>
                                </div>
                                <div class="col-md-12" style="margin-top: 10px">
                                    <a href="#" id="btn-remove-img-foto"
                                        class="jFiler-item-trash-action btn btn-sm btn-flat btn-danger btn-file"
                                        @if (isset($registro) && $registro->capa == null) style="display: none;" @endif>
                                        <i class="fa fa-trash-o" aria-hidden="true"></i> Remover Imagem
                                    </a>
                                    <div id="btn-upload-img-foto" class="btn btn-sm btn-flat btn-primary btn-file "
                                        @if (isset($registro) && $registro->capa != null) style="display: none;" @endif>


                                        <i class="fa fa-camera" aria-hidden="true"></i> Selecionar Imagem
                                        <input type="file" name="arquivo_principal" id="upload-img-foto"
                                            accept="image/*">

                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="col-xs-12 col-md-7 mb-3">

                        <label>Texto</label>
                        <textarea type="textarea" name="texto"
                            class="textarea form-control {{ $errors->has('texto') ? 'is-invalid' : '' }}">

                            @if (isset($registro->texto))
                            {!! $registro->texto !!}
                        @else
                            {!! old('texto') !!}
                            @endif
                        </textarea>
                        @if ($errors->has('texto'))
                            <div class="invalid-feedback">
                                <strong>{{ $errors->first('texto') }}</strong>
                            </div>
                        @endif
                    </div>
                </div>

                <div class="box-footer">
                    <div class="text-right">
                        <a href="{{ route('home') }}" class="btn btn-default">
                            <i class="fa fa-angle-double-left" aria-hidden="true"></i> Voltar
                        </a>
                        <button class="btn btn-success btn-submit" type="submit">
                            <i class="fa fa-save"></i> Salvar
                        </button>

                    </div>
                </div>
                </form>
            </div>

        </div>
    </div>
</div>
@stop

@section('css')

<style type="text/css">
    .custom-file-label::after {
        content: "Selecionar";
    }

</style>
@stop

@section('js')
<script src="{{ asset('vendor/bs-custom-file-input/bs-custom-file-input.min.js') }}"></script>
<script src="{{ asset('vendor/summernote/lang/summernote-pt-BR.js') }}"></script>
<script src="{{ asset('vendor/inputmask/min/jquery.inputmask.bundle.min.js') }}"></script>
<script>
    $(document).ready(function() {
        $('.mask').inputmask('##/##/###', {
            'placeholder': '__/__/_____'
        });

        bsCustomFileInput.init();


        $(".textarea").summernote({
            lang: "pt-BR",
            height: 300
        });

        imgFoto();

    });

    //croopie
    function imgFoto() {
        let $uploadCrop;
        let config = {
            viewport: {
                width: 350,
                height: 255,
                type: 'square'
            },
            boundary: {
                width: 350,
                height: 255
            },
            enableExif: true
        };

        function readFile(input) {

            if (input.files && input.files[0]) {
                let reader = new FileReader();
                reader.onload = function(e) {
                    $('#img-foto').croppie('destroy');
                    $('#img-foto').croppie(config);
                    $uploadCrop.croppie('bind', {
                        url: e.target.result,
                    }).then(function(res) {
                        $('#btn-upload-img-foto').hide();
                        $('#aviso-remover').hide();

                        $('#btn-remove-img-foto').show();
                        $('#aviso-mover').show();
                    });
                };
                reader.readAsDataURL(input.files[0]);
            } else {
                swal(
                    "Desculpe - o navegador não suporta a API FileReader! Use um navegador mais moderno como Chrome ou Firefox!");
            }
        }

        $uploadCrop = $('#img-foto').croppie(config);
        if ($uploadCrop.length > 0) {
            setImgDefaultFoto($uploadCrop);
        }

        $('#upload-img-foto').on('change', function() {

            //console.log(this);
            // Verifica se #img-foto é visivel
            if ($('.img-foto-wrap').children('img').length > 0 && $('.img-foto-wrap').children('img').is(
                    ':visible') == true) {
                $('.img-foto-wrap').children('img').hide();
                $('#img-foto').show();
            }
            readFile(this);
        });

        $('#btn-remove-img-foto').on('click', function(e) {
            e.preventDefault();
            if ($('.img-foto-wrap').children('img').length > 0 && $('.img-foto-wrap').children('img').is(
                    ':visible') == true) {
                $('.img-foto-wrap').children('img').hide();
                $('#img-foto').show();
                $('#aviso-remover').hide();
            }
            setImgDefaultFoto($uploadCrop);
        });

        // Seta imagem quando clicado em btn-submit
        $('.btn-submit').on('click', function(ev) {

            // Verifica se o o btn-remove é visivel, se for é feito o result do croppie
            if ($('#btn-remove-img-foto:visible').length > 0 && $('.img-foto-wrap').children('img').is(
                    ':visible') == false) {
                $uploadCrop.croppie('result', {
                    type: 'base64',
                    size: 'viewport',
                }).then(function(resp) {
                    $('#imagebase64').val(resp);
                });
            }
        });
    }
    

    function setImgDefaultFoto($uploadCrop) {
        let imgDefaultFoto = ($('#img-foto:visible').data('img-default-foto')) ? $('#img-foto').data(
            'img-default-foto') : null;
        if (imgDefaultFoto != null) {
            $('#imagebase64').val('default.png');
            $('#upload-img-foto').val('');


            $('#btn-upload-img-foto').show();
            //$('#aviso-remover').show();

            $('#btn-remove-img-foto').hide();
            $('#aviso-mover').hide();

            $uploadCrop.croppie('bind', {
                url: imgDefaultFoto,
                //points: [0, 50,0,50],
            });
        }
    }
</script>
@stop

resources/views/posts/index.blade.php
@extends('layout.base')

@section('title', 'Posts')

@section('content_header')
<h1>Posts</h1>
@stop

@section('breadcrumb')
<li class="breadcrumb-item active">Posts</li>
@endsection

@section('acoes')
<a href="{{ route('posts.create') }}" class="btn btn-sm btn-primary" data-toggle="tooltip" title="Novo">
  <i class="fa fa-plus"></i>
  Novo
</a>
<a href="{{ route('home') }}" class="btn btn-sm btn-default" data-toggle="tooltip" title="Voltar">
  <i class="fa fa-reply"></i> Voltar
</a>
@endsection

@section('content')
@section('plugins.Datatables', true)
@section('plugins.Sweetalert2', true)
<div class="row">
    <div class="col-md-12">
        @include('mensagem') 
        <div class="card">     
            <div class="card-body table-responsive">                
                <table class="table table-bordered table-hover dataTable dtr-inline">
                    <thead>
                        <tr>
                            <th>Código</th>
                            <th>Nome</th>
                            <th>Data do Post</th>
                            <th>Criado em</th>
                            <th class="text-right no-print">Ações</th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach($registros as $registro)
                        <tr>
                            <td>{{ $registro->id }}</td>
                            <td> <a href="#" target="_blank">{{ $registro->titulo }}</a></td>

                            <td> {{ $registro->data_hora }}</td>
                            <td> {{ $registro->created_at }}</td>
                            <td class="text-right">

                                <form action="{{ route('posts.destroy', $registro->id) }}" method="POST">       
                                   @csrf
                                   @method('delete')
                                   <a href="{{ route('posts.edit', $registro->id) }}" class="btn  btn-sm btn-primary" data-toggle="tooltip" title="Editar">
                                    <i class="fas fa-edit"></i>
                                </a>
                                <button type="submit" class="delete btn  btn-sm btn-danger" data-toggle="tooltip" title="Excluir">
                                    <i class="fa fa-trash"></i>
                                </button> 

                            </form>

                        </td>                            
                    </tr>
                    @endforeach  
                </tbody>
            </table>               
        </div>
    </div>

</div>
</div>

@stop

@section('css')

@stop

@section('js')
<script> 
    $(function () {
        $(".dataTable").DataTable({
            "order": [[ 1, "desc" ]],
            "responsive": true,
            "autoWidth": false,
            "language": {
                "url": "//cdn.datatables.net/plug-ins/1.10.21/i18n/Portuguese-Brasil.json"
            }
        });
    });

    $("body").on("click", ".delete", function(e) {

        e.preventDefault();
        form = $(this).closest('form');
        botao = $(this);
        Swal.fire({
            title: 'Você deseja excluir o registro?',
            type: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Sim, desejo excluir!',
            cancelButtonText: 'Não, cancelar!',
        }).then((result) => {
            if (result.value) {
                botao.data('loading-text', '<i class="fa fa-refresh fa-spin"></i> Excluindo...');
                botao.button('loading');
                botao.attr('disabled');
                form.submit();
            }
        })
    });
</script>
@stop